
// *****************************************************************************
//
// source:    AC_ECAL_evnt.C
//
// type:      source code
//
// created:   22 May 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    AC_ECAL_evnt()
//
// called by: AC_evnt()
//
// changes:
// 18 May 2000 (AG) creation on request of S. Shuvalov
// 22 May 2000 (AG) add this comments
//
// *****************************************************************************

// ARTE includes
#include <alca/AC_ECAL.h>
#include "farm/farm.hh"

//
// program code
//
int AC_ECAL_evnt()
{
  // mark
  ARTE_mark( "AC_ECAL_evnt", 0 );

  // call ECAL evnt function
  AC_ECAL_ihists_event();

  return 0;
}
