
// ********************************************************************
//
// source:    acReadDQ.C
//
// type:      source code
//
// created:   26 Oct 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: acread_()
//
// purpose:   handle new DB table
//
// changes:
// 29 Oct 1999 (AG) remove print-out
// 17 Nov 1999 (AG) prepare for CNA
// 03 Dec 1999 (AG) remove printouts
//
// ********************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes

// Arte includes

//
// function
//
int
acReadDQ( int KTstatus )
{
  // show up
  //cout << "acReadDQ(): KTstatus=" << KTstatus << endl;
  
  // check keytable status
  if( KTstatus == -2 ){
    //cout << "acReadDQ(): no keytable loaded" << endl;
  }
  else if( KTstatus == 0 ){
    //cout << "acReadDQ(): no changes or wrong version" << endl;
  }
  else if( KTstatus == 1 ){
    //cout << "acReadDQ(): information updated" << endl;
  }
  else if( KTstatus == 2 ){
    //cout << "acReadDQ(): keytable has changed" << endl;
  }
  else {
    //cout << "acReadDQ(): What??? KTstatus=" << KTstatus << endl;
  }

  return KTstatus;
}
