*CMZ :          05/07/96  11.24.10  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  14.20.40  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   20/12/95

      SUBROUTINE ALINIT

************************************************************************
*
* Description: Lund initialization
*
* Called from: ATEVNT
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

      INTEGER LO

      INTEGER KSZJ,KSZ1,KSZ2
      PARAMETER (KSZJ=4000,KSZ1=20,KSZ2=300)
      INTEGER MSTU,MSTJ
      REAL PARU,PARJ
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER KFR
      REAL VFR
      COMMON/FRPARA1/KFR(KSZ1),VFR(KSZ1)
      INTEGER IOP,NFR
      REAL PLI0, AOP
      COMMON/FRINTN0/PLI0(2,4),AOP(KSZ1),IOP(KSZ1),NFR(KSZ1)
      INTEGER MSTA
      REAL PARA
      COMMON/ARDAT1/PARA(40),MSTA(40)

#include "arte/ArteFlag.fi"

      CALL MEWARC (1345134, 'ALINIT: initialize LUND')
      CALL PYINIT ('FIXT', 'p+', 'n0', HERAEBEAM)

C code from FREVENT:

      DO 12 LO=1, KSZ1
12    NFR(LO)= 0
C.....     set some control parameters for Ariadne and jetset:
      MSTA(7) = MSTU(11)
      MSTA(8) = MSTU(11)
      MSTA(9) = 0
      MSTA(14) = 0
C.....extended partons made massless, for compatibility with AR3.03
      MSTA(31) = 0

        IF(KFR(12).EQ.1) THEN
C             Fragmentation parameters set to the Opal optimized values:
        CALL ARTUNE('OPAL')
        ELSEIF(KFR(12).GE.2) THEN
C                               DELPHI optimized values
        CALL ARTUNE('DELPHI')
        ENDIF
      CALL ARINIT('ARIADNE')

      END

************************************************************************
* End of ALINIT
************************************************************************
