*-- Author :    Hartwig Albrecht   10/07/97

      SUBROUTINE CHTTOC (T, C)

************************************************************************
*
* Description: copy C text string T (terminated by \n) into C.
*              The rest of C is filled with blank spaces.
*
* Called from: anywhere
*
* External references: UHTOC
*
* Argument in/out description
*   T      in     array.
*   C      out    output character string.
*
************************************************************************

      IMPLICIT NONE

#include "arte/ArteFlag.fi"

      INTEGER T(*), I, J
      CHARACTER C*(*)

      CALL UHTOC  (T, 4, C, LEN(C))

      J = 0
      DO I = 1, LEN(C)
        IF (C(I:I) .EQ. CHNULL)  J = 1
        IF (J .NE. 0)  C(I:I) = ' '
      END DO
         
      END

************************************************************************
* End of CHTTOC
************************************************************************
