*-- Author :    Hartwig Albrecht   24/05/95

      SUBROUTINE DDTABL

************************************************************************
*
* Description: make initialization sequence ArteTable.h
*
* Called from:
*
* External reference:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, NC, NF, NO, IO, ISUB, ILO, IUP,
     +  L, LENOCC, CHCMPN
      REAL FLO, FUP, FAC
      CHARACTER C*200, CU*80, CL*80, CSUB*80, CFC*1, CFF*1, CFT*500,
     +   CIO*80, C16*16
      DATA CFT /'  dfzebf_(", '/

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL DDOPEN ('ArteTable', 'h')

      WRITE (LDDEF, 1001)
     +  '/* Created automatically by arte/ddtabl.F */'
      WRITE (LDDEF, 1001)
      WRITE (LDDEF, 1001)
     +  '#include "arte/Arte.h"'
      WRITE (LDDEF, 1001)
      WRITE (LDDEF, 1001)  '#ifdef __cplusplus'
      WRITE (LDDEF, 1001)  'extern "C" {'
      WRITE (LDDEF, 1001)  '#endif'
      WRITE (LDDEF, 1001)
      WRITE (LDDEF, 1001)
     +  'extern int dftabl (int *link, char *name, int div, int col,'
      WRITE (LDDEF, 1001)
     +  '  int outcol, int extension, char *iofiles);'
      WRITE (LDDEF, 1001)
     +  'extern int dftabs (int *link, char *name, int div, int col,'
      WRITE (LDDEF, 1001)
     +  '  int outcol, int extension, int *link_sup, char *iofiles);'
      WRITE (LDDEF, 1001)
     +  'extern int dftabp (int *link, char *name, int div, int col,'
      WRITE (LDDEF, 1001)
     +  '  int outcol, int extension, int *link_sup, char *iofiles);'
      WRITE (LDDEF, 1001)
     +  'extern int dfrela (int *link, char *name, int div, int *tab1,'
      WRITE (LDDEF, 1001)
     +  '  int pos1, int *tab2, int pos2, int type);'
      WRITE (LDDEF, 1001)
     +  'extern int dfzebf_ (char *zebra_format);'
      WRITE (LDDEF, 1001)
     +  'extern int dfattb (char *name, int nbits);'
      WRITE (LDDEF, 1001)
     +  'extern int dfat0b (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfattc (char *name, int dim);'
      WRITE (LDDEF, 1001)
     +  'extern int dfattf (char *name, float lower, float upper,' //
     +  '  float accuracy);'
      WRITE (LDDEF, 1001)
     +  'extern int dfat0f (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfatth (char *name, int dim);'
      WRITE (LDDEF, 1001)
     +  'extern int dfatti (char *name, int lower, int upper);'
      WRITE (LDDEF, 1001)
     +  'extern int dfat0i (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfattr (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfatts (char *name, int lower, int upper);'
      WRITE (LDDEF, 1001)
     +  'extern int dfat0s (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfattu (char *name, int nbits);'
      WRITE (LDDEF, 1001)
     +  'extern int dfat0u (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfaltb (char *name, int nbits);'
      WRITE (LDDEF, 1001)
     +  'extern int dfal0b (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfaltc (char *name, int dim);'
      WRITE (LDDEF, 1001)
     +  'extern int dfaltf (char *name, float lower, float upper,' //
     +  '  float accuracy);'
      WRITE (LDDEF, 1001)
     +  'extern int dfal0f (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfalth (char *name, int dim);'
      WRITE (LDDEF, 1001)
     +  'extern int dfalti (char *name, int lower, int upper);'
      WRITE (LDDEF, 1001)
     +  'extern int dfal0i (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfaltr (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfalts (char *name, int lower, int upper);'
      WRITE (LDDEF, 1001)
     +  'extern int dfal0s (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfaltu (char *name, int nbits);'
      WRITE (LDDEF, 1001)
     +  'extern int dfal0u (char *name);'
      WRITE (LDDEF, 1001)
     +  'extern int dfattp (char *name, int *link);'
      WRITE (LDDEF, 1001)  'void usautt_() {'

      DO 70 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 70

        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CU)
        CL = CU
        CALL CUTOL (CL)

        C(1:) = '/*'
        CALL CHAPBC (C, CU)
        CALL CHHTOC (IQ(HQDDEF_TEXT(1,K1)), CIO)
        CALL CHAPBC (C, CIO)
        CALL CHAPBC (C, '*/')
        WRITE (LDDEF, 1001)  ' '
        WRITE (LDDEF, 1001)  C(1:LENOCC(C))
        WRITE (LDDEF, 1001)  ' '

        NC = 0
        NF = 0
        NO = 0
        IO = 0
        CIO = ' '
        CFC = ' '
        CFF = ' '
        CSUB = ' '
        ISUB = 0
        CFT(12:) = ' '

        DO 10 K2 = K1 + 1, NDDEF()

          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 20

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_END)  IO = 1

          IF (IDDEF_FLAG(K2) .GE. LDDEF_ATT .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_INM)  THEN

            IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
              NC = NC + MAX (IDDEF_DIM(K2), 1)
              CALL CHHTOC (IQ(HQDDEF_NAM2(1,K2)), CFC)
              IF (CFC .EQ. 'S')  CFC = 'I'
              IF (CFC .EQ. 'U')  CFC = 'B'
              IF (CFC .EQ. 'C')  CFC = 'H'
            ELSE
              NC = NC + 1
              CFC = 'I'
            END IF

            IF (IO .EQ. 0)  THEN
              NO = NC
            ELSE
              GO TO 10
            END IF

            IF (CFC .EQ. CFF)  THEN
              NF = NF + MAX (IDDEF_DIM(K2), 1)
            ELSE
              IF (NF .NE. 0)  THEN
                CALL CHAPPI (CFT, NF)
                CALL CHAPPC (CFT, CFF)
              END IF
              CFF = CFC
              NF = MAX (IDDEF_DIM(K2), 1)
            END IF

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_FIL)  THEN

            IF (CIO .EQ. ' ')  THEN
              CALL CHHTOC (IQ(HQDDEF_TEXT(1,K2)), CIO)
            ELSE
              CALL MEWARC (76354,
     +          'only one DFFILE command allowed for table ' // CU)
            END IF
            GO TO 10

          ELSE IF (IDDEF_FLAG(K2) .GE. LDDEF_SUB .AND.
     +             IDDEF_FLAG(K2) .LE. LDDEF_PAR)  THEN
            ISUB = IDDEF_FLAG(K2) - LDDEF_SUB + 1
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CSUB)
            CALL CUTOL (CSUB)
          END IF
 10     CONTINUE

 20     C = '  dftabl (&artelink_.j'
        CALL CHAPPC (C, CL)
        CALL CHAPPC (C, ', "')
        CALL CHAPPC (C, CU)
        CALL CHAPPC (C, '",')
        CALL CHAPBI (C, IDDEF_DIV(K1))
        CALL CHAPPC (C, ',')
        CALL CHAPBI (C, NC)
        CALL CHAPPC (C, ',')
        CALL CHAPBI (C, NO)
        CALL CHAPPC (C, ',')
        CALL CHAPBI (C, IDDEF_DIM(K1))
        CALL CHAPPC (C, ',')

        IF (ISUB .NE. 0)  THEN
          C(8:8) = 's'
          IF (ISUB .EQ. 2)  C(8:8) = 'p'
          CALL CHAPBC (C, '&artelink_.j')
          CALL CHAPPC (C, CSUB)
          CALL CHAPPC (C, ',')
        END IF

        WRITE (LDDEF, 1001)  C(1:LENOCC(C))

        C = '    "'
        CALL CHAPPC (C, CIO)
        CALL CHAPPC (C, '");')
        WRITE (LDDEF, 1001)  C(1:LENOCC(C))

        IF (NF .NE. 0)  THEN
          CALL CHAPPI (CFT, NF)
          CALL CHAPPC (CFT, CFF)
        END IF

        CALL CHAPPC (CFT, '");')
        WRITE (LDDEF, 1001)  CFT(1:LENOCC(CFT))

C subroutine calls for attribute description

        DO 60 K2 = K1 + 1, NDDEF()

          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 70

          C = '  dfattX ("'
          IF (IDDEF_KEY(K2) .NE. 0)  C(6:6) = 'l'
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CL)
          CALL CUTOL (CL)
          CALL CHAPPC (C, CL)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN

            CALL CHAPPC (C, '"')
            CALL CHHTOC (IQ(HQDDEF_NAM2(1,K2)), CFC)
            C(8:8) = CFC
            CALL CUTOL (C(8:8))
            ILO = ISMALLEST
            IUP = ILARGEST
            FLO = -FLARGEST
            FUP = FLARGEST
            FAC = 0.
            IF (CFC .EQ. 'S')  THEN
              ILO = SSMALLEST
              IUP = SLARGEST
            ELSE IF (CFC .EQ. 'B')  THEN
              ILO = 0
              IUP = 32
            ELSE IF (CFC .EQ. 'U')  THEN
              ILO = 0
              IUP = 16
            ELSE IF (CFC .EQ. 'H' .OR. CFC .EQ. 'C')  THEN
              CALL CHAPCI (C, MAX (IDDEF_DIM(K2), 1))
              CALL CHAPPC (C, ');')
              WRITE (LDDEF, 1001)  C(1:LENOCC(C))
              GO TO 60
            END IF

            K3 = K2
            IO = 0

            L = LENOCC (C)
            DO 40 NC = 1, MAX (IDDEF_DIM(K2), 1)

 30           K3 = K3 + 1
              IF (IDDEF_FLAG(K3) .EQ. LDDEF_SKP .OR.
     +            IDDEF_FLAG(K3) .EQ. LDDEF_TEX)  GO TO 30
              IO = IO + 1

              IF (IDDEF_FLAG(K3) .EQ. LDDEF_ILO)  THEN
                ILO = IDDEF_RFLG(K3)
                IUP = ILARGEST
                IF (CFC .EQ. 'S')  IUP = SLARGEST
              ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_IUP)  THEN
                ILO = ISMALLEST
                IF (CFC .EQ. 'S')  IUP = SSMALLEST
                IUP = IDDEF_DIV(K3)
              ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_IRA)  THEN
                ILO = IDDEF_RFLG(K3)
                IUP = IDDEF_DIV(K3)
              ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_FLO)  THEN
                FLO = FDDEF_FLO(K3)
                FUP = FLARGEST
                FAC = FDDEF_FAC(K3)
              ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_FUP)  THEN
                FLO = -FLARGEST
                FUP = FDDEF_FUP(K3)
                FAC = FDDEF_FAC(K3)
              ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_FRA)  THEN
                FLO = FDDEF_FLO(K3)
                FUP = FDDEF_FUP(K3)
                FAC = FDDEF_FAC(K3)
              ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_NBI)  THEN
                IUP = IDDEF_RFLG(K3)
              ELSE
                K3 = K3 - 1
                IO = IO - 1
              END IF

              IF (IO .EQ. 0)  THEN
                IF (C(7:7) .NE. '0')  CALL CHAPPC (C, ');')
                C(7:7) = '0'
                WRITE (LDDEF, 1001)  C(1:LENOCC(C))
                GO TO 40
              END IF
              C(L+1:) = ' '

              IF (CFC .EQ. 'I' .OR. CFC .EQ. 'S')  THEN
                CALL CHAPCI (C, ILO)
                CALL CHAPCI (C, IUP)
              ELSE IF (CFC .EQ. 'F')  THEN
                IF (FLO .NE. 0.)  THEN
                  WRITE (C16, '(G16.8)')  FLO
                  CALL CHLEFT (C16)
                ELSE
                  C16 = ' 0.0'
                END IF
                CALL CHAPCC (C, C16)
                IF (FUP .NE. 0.)  THEN
                  WRITE (C16, '(G16.8)')  FUP
                  CALL CHLEFT (C16)
                ELSE
                  C16 = '0.0'
                END IF
                CALL CHAPCC (C, C16)
                IF (FAC .NE. 0.)  THEN
                  WRITE (C16, '(G16.8)')  FAC
                  CALL CHLEFT (C16)
                ELSE
                  C16 = '0.0'
                END IF
                CALL CHAPCC (C, C16)
              ELSE
                CALL CHAPCI (C, IUP)
              END IF

              CALL CHAPPC (C, ');')
              WRITE (LDDEF, 1001)  C(1:LENOCC(C))
                
 40         CONTINUE

C pointer
          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_POI)  THEN
            C(8:8) = 'p'
            CALL CHAPPC (C, '",&artelink_.j')
            CALL CHHTOC (IQ(HQDDEF_NAM2(1,K2)), CL)
            CALL CUTOL (CL)
            CALL CHAPPC (C, CL)
            CALL CHAPPC (C, ');')
            WRITE (LDDEF, 1001)  C(1:LENOCC(C))

C relation

          ELSE IF (IDDEF_FLAG(K2) .GE. LDDEF_RE1 .AND.
     +             IDDEF_FLAG(K2) .LE. LDDEF_INM)  THEN
            C(8:8) = 'r'
            CALL CHAPPC (C, '");')
            WRITE (LDDEF, 1001)  C(1:LENOCC(C))
          END IF

 60     CONTINUE
 70   CONTINUE

C relations

      WRITE (LDDEF, 1001)
      WRITE (LDDEF, 1001) '/* relations */'
      WRITE (LDDEF, 1001)

      DO 240 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .LT. LDDEF_RE1 .OR.
     +      IDDEF_FLAG(K1) .GT. LDDEF_REM)  GO TO 240

        C = '  dfrela (&artelink_.j'
        CALL CHHTOC (IQ(HQDDEF_NAM3(1,K1)), CL)
        CALL CUTOL (CL)
        CALL CHAPPC (C, CL)
        CALL CHAPPC (C, ', "')
        CALL CLTOU (CL)
        CALL CHAPPC (C, CL)
        CALL CHAPPC (C, '",')
        CALL CHAPBI (C, IDDEF_DIV(K1))
        CALL CHAPPC (C, ',')
        WRITE (LDDEF, 1001)  C(1:LENOCC(C))

        DO 210 K3 = K1, 1, -1
          IF (IDDEF_FLAG(K3) .EQ. LDDEF_TAB)  GO TO 220
 210    CONTINUE
 220    CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CL)
        CALL CUTOL (CL)
        C = '    &artelink_.j'
        CALL CHAPPC (C, CL)
        CALL CHAPPC (C, ',')
        CALL CHAPBI (C, IDDEF_COL(K1))

        DO 230 K2 = 1, NDDEF()

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
          IF (CHCMPN (IQ(HQDDEF_NAM3(1,K1)),
     +                IQ(HQDDEF_NAM3(1,K2))).EQ. 0)   GO TO 230
          IF (IDDEF_FLAG(K2) .LT. LDDEF_IN1 .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 230

          CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CL)
          CALL CUTOL (CL)
          CALL CHAPPC (C, ', &artelink_.j')
          CALL CHAPPC (C, CL)
          CALL CHAPPC (C, ',')
          CALL CHAPBI (C, IDDEF_COL(K2))
          CALL CHAPPC (C, ',')
          CALL CHAPBI (C, IDDEF_RFLG(K1))
          CALL CHAPPC (C, ');')
          WRITE (LDDEF, 1001)  C(1:LENOCC(C))
          GO TO 240

 230    CONTINUE

 240  CONTINUE

      WRITE (LDDEF, 1001)
      WRITE (LDDEF, 1001)  '}'
      WRITE (LDDEF, 1001)  '#ifdef __cplusplus'
      WRITE (LDDEF, 1001)  '}'
      WRITE (LDDEF, 1001)  '#endif'

 1001 FORMAT (A)

      END

************************************************************************
* End of DDTABL
************************************************************************
