
      LOGICAL FUNCTION PTLRIN( CIN , CMARK , IOUT ) 
**************************************************************************
*                                                                        *
* PPPPPPPPP   TTTTTTTTTT  LL        RRRRRRRRR    IIIIIIII   NN        NN *
* PPPPPPPPPP  TTTTTTTTTT  LL        RRRRRRRRRR   IIIIIIII   NNN       NN *
* PP      PP      TT      LL        RR      RR      II      NNNN      NN *
* PP      PP      TT      LL        RR      RR      II      NN NN     NN *
* PP      PP      TT      LL        RR      RR      II      NN  NN    NN *
* PPPPPPPPPP      TT      LL        RRRRRRRRRR      II      NN   NN   NN *
* PPPPPPPPP       TT      LL        RRRRRRRRR       II      NN    NN  NN *
* PP              TT      LL        RR  RR          II      NN     NN NN *
* PP              TT      LL        RR   RR         II      NN      NNNN *
* PP              TT      LL        RR    RR        II      NN       NNN *
* PP              TT      LLLLLLLL  RR     RR    IIIIIIII   NN        NN *
* PP              TT      LLLLLLLL  RR      RR   IIIIIIII   NN         N *
*                                                                        *
**************************************************************************
*                                                                        *
* Author: I.Belyaev                                                      *
* Date: 1997/6/20                                                        *
*                                                                        *
* Description:                                                           *
* read integer value from CIN and put it into IOUT                       *
* Called from: anywhere                                                  *
*                                                                        *
* Arguments:                                                             *
* name       in/out/update Argument description                          *
* CIN         character input                                            *
* CMARK       character MARK                                             *
* IOUT        integer      output                                        *
**************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

       CHARACTER*(*)  CIN 
       CHARACTER*(*)  CMARK 
       INTEGER        IOUT,IVALUE   
       INTEGER        LENOCC 
       LOGICAL        LOUT   

       EXTERNAL       LENOCC 

#include "arte/Arte.ff"

      IF( LENOCC(CIN) .LE. 0 )THEN
       C78='PTLRRE error ==> LENOCC(CIN)='
       CALL CH78AI( LENOCC(CIN) ) 
       CALL ME78EC( 823746 )   ! in BATCH mode stop 
      ENDIF 

      IF( LENOCC(CMARK) .LE. 0 )THEN
       C78='PTLRRE error ==> LENOCC(CMARK)='
       CALL CH78AI( LENOCC(CMARK) ) 
       CALL ME78EC( 342508 )   ! in BATCH mode stop 
      ENDIF 

      READ(CIN(1:LENOCC(CIN)),*,ERR=1)IVALUE  
 
      LOUT = .TRUE. 
      GO TO 2 

 1    CONTINUE 

      C78 = 'PTLRIN error. impossible to read=' 
      CALL CH78AC( CIN(1:LENOCC(CIN) ) ) 
      CALL CH78BC( 'for mark='         )
      CALL CH78AC( CMARK(1:LENOCC(CMARK)))
      CALL ME78EC( 325445  )   ! in BATCH mode stop 
      LOUT   = .FALSE. 
      IVALUE = 0 
   
 2    CONTINUE 
 

      IOUT   = IVALUE 
      PTLRIN = LOUT 

      RETURN 
      END
