//
// T. Zeuner 10/02/00 ItrStartup 
// Initialize Ledatables for ITR
// 
// 

// some Arte stuff
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "ITR_arte.h"
#include "ITR_EVinfo.h"
#include "iol.h"

// return codes
#include "grr.h"


// prototype declarations
#include "aframelib.h"
#include "itrleda.h"
#include "ITR_silraw.h"
#include "ITR_marvin.h"

int ItrStartup() {

  // protection against multiple calls
  static bool ITRfirsttime = true;

  char *routine = "ItrStartup";

  if (!ITRfirsttime) {
    aframe_mess(routine, GRR_SINFO, "ItrStartup called more than once !");
    return GRR_OK;
  }
  else
    ITRfirsttime = false;
  
  // initialize ITR_leda without LedaCheckDD  

  int rc = ITR_leda_initialize(-1);
  if ( rc != GRR_OK ) return rc;

  return GRR_OK;
}
