*CMZ :  1.00/00 03/01/95  10.57.46  by  Dominik Ressing
*CMZ :  0.01/02 26/08/94  17.19.18  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/08/94
************************************************************************
*
* L1MESDP
* written by Dominik Ressing, 18/08/94 20.12.37
*
* This routines action:
* Duplicate message Iold to Inew. If no success Inew is set to 0.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* Iold        in          Pointer to Input message
* Inew        out         Pointer to Output message
*
************************************************************************
c
      SUBROUTINE L1MESDP(Iold,Inew)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
c
      INTEGER Iold,Inew
c
      CALL l1mesne(L1MEstor(Iold+L1MEprbx),Inew) ! get new message
      IF ( Inew.le.0 ) RETURN                    ! no success
c
      CALL L1MESCP(Iold,Inew)                    ! copy contents
c
      RETURN
c
      END
