*-- Author :    Rainer Mankel   17/02/96

*-- additions by A. Somov   Dec-98

      subroutine diplac(sl,chopt)

*     **** display all ECAL blocks
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

      character*(*) chopt
      real xxx(5), yyy(5), wc(3,4)
      integer ii, pl, sl
      integer block, xsig(4), ysig(4), ncell, ncell1
      real dx, dy, wc1(5)

#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

          data xsig /-1, +1, +1, -1/, ysig /-1, -1, +1, +1/
*     **** loop over ECAL blocks
      do 10 pl=1,ngcal()

         if (sl.gt.0) then      ! check SL
            if (ogcal_gesl(pl).ne.sl) go to 10
         endif

         wc(1,1) = fgcal_xmin(pl)
         wc(2,1) = fgcal_ymin(pl)
         wc(3,1) = fgcal_zmin(pl)
         wc(1,2) = fgcal_xmax(pl)
         wc(2,2) = fgcal_ymin(pl)
         wc(3,2) = fgcal_zmin(pl)
         wc(1,3) = fgcal_xmax(pl)
         wc(2,3) = fgcal_ymax(pl)
         wc(3,3) = fgcal_zmin(pl)
         wc(1,4) = fgcal_xmin(pl)
         wc(2,4) = fgcal_ymax(pl)
         wc(3,4) = fgcal_zmin(pl)

** ECAL block structure
         block = pl
         dx = (fgcal_xmax(block) - fgcal_xmin(block)) / igcal_ncl(block)
         dy = (fgcal_ymax(block) - fgcal_ymin(block)) / igcal_ncl(block)

****  projection
*         print *,'igcal_ncl(block)',igcal_ncl(block)
         do ncell=1,igcal_ncl(block)
         do ncell1=1,igcal_ncl(block) 
          do ii=1,4
             wc1(1) = fgcal_xmin(pl) + (ncell - (xsig(ii) + 1.)/2.)*dx
             wc1(2) = fgcal_ymin(pl) + (ncell1 - (ysig(ii) + 1.)/2.)*dy 
             wc1(3) = fgcal_zmin(pl) 
             if (wc1(3).ne.0.) then
                wc1(4) = atan( wc1(1) / wc1(3) )
                wc1(5) = atan( wc1(2) / wc1(3) )
             else
                wc1(4) = 20000.
                wc1(5) = 20000.
             endif
             call dipro5(wc1,xxx(ii),yyy(ii))
          enddo

*        **** close the parallelogram
         xxx(5) = xxx(1)
         yyy(5) = yyy(1)

*        **** draw plane
         call isplci(int(coplbzg))
         call igsg(1)
         call isln(1)

*        **** draw plane volume if opaque option active
         if (lopaquezg) then
            call igset('PLCI',coplvzg)
            call igset('FACI',coplvzg)
            call igset('FAIS',1.)
            call igset('BORD',0.)
            call ifa(5,xxx,yyy)
         endif
*        **** draw plane border
         call igset('PLCI',coplbzg)
         call igset('FAIS',0.)
         call igset('LWID',1.)
         call ipl(5,xxx,yyy)

         call isfaci(0)
         call isfais(0)
      enddo
      enddo
 10   continue

      end





