*-- Author :    Rainer Mankel   02/04/96

      subroutine dirccl(sl,clus,idmc,chopt)

*     **** display ECAL hits
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

      character*(*) chopt
      real xxx(5), yyy(5), wc(3), zb, dx, dy, e, col
      integer sl, idmc, clus, clus1, clus2, hc, block, cell, ii,
     +    j, xsig(4), ysig(4), gcce, igcal 
**
      integer indx,ir,ir1
**
#include "auto/GEO.fi"
#include "auto/HITC.fi"
#include "auto/MCAL.fi" 
#include "auto/REC.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITC.ff"
#include "auto/MCAL.ff"
#include "auto/REC.ff"
      data xsig /-1, +1, +1, -1/, ysig /-1, -1, +1, +1/

      if (clus.gt.0) then
         clus1 = clus
         clus2 = clus
      else
         clus1 = 1
         clus2 = NRCCL()
      endif
      if (clus2.eq.0) then
        print *,'---> dirccl() - no clusters found'
        go to 999
      endif
*****
** Clustering
*****
         do 10 ir=clus1,clus2
            indx=prccl_hitc(ir)
            do ir1=1,100
              if(indx.gt.0) then
                 hc=mrccl_hitc(indx)                      
                 wc(1) = fhitc_x(hc)
                 wc(2) = fhitc_y(hc)
                 gcce = ihitc_gcce(hc)
                 igcal = igcce_ceid(gcce)
                 block = igcal / 100
                 cell = mod(igcal,100)
                 if (block.ge.1.and.block.le.ngcal()) then
                    zb = fgcal_zmin(block)
                 else
                    print *,' () dirccl: block out of range, ', block
                    zb = 1500.
                 endif
                 wc(3) = zb  

                 dx = (fgcal_xmax(block) - fgcal_xmin(block)) /
     +                                    igcal_ncl(block)
                 dy = (fgcal_ymax(block) - fgcal_ymin(block)) /
     +                                    igcal_ncl(block)

                 do ii=1,4
                    wc(1) = fhitc_x(hc) + xsig(ii) * 0.5 * dx
                    wc(2) = fhitc_y(hc) + ysig(ii) * 0.5 * dy
                    wc(3) = zb
                    call dipro(wc,xxx(ii),yyy(ii))
                 enddo
                 xxx(5) = xxx(1)
                 yyy(5) = yyy(1)

                 e = fhitc_q(hc)
                 if (e.gt.0.01) then
                    j = alog(e) / alog(3.)
                    if (j.le.-2) then
                      col = coca1zg
                    elseif (j.eq.-1) then
                      col = coca2zg
                    elseif (j.eq.0) then
                      col = coca3zg
                    elseif (j.eq.1) then
                      col = coca4zg
                    else
                      col = coca5zg
                    endif
                    call igset('FAIS',1.)
                    call igset('FACI',col) 
                    call ifa(5,xxx,yyy)
                    call igset('PLCI',cocebzg)
                    call ipl(5,xxx,yyy)
                 endif
                 indx=xrccl_hitc(indx)   
              else 
               go to 10
              endif
            enddo          
      print *,'dirccl: IR===',ir
 10   continue                     

 999  end

