*-- Author :    Rainer Mankel   04/08/94

      subroutine tusomh()

*     **** fill mc access buffer /zmh/
      implicit none
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "pris/zmh.fi"
      integer iii, imc, nso, imi, imh, imiso(nmimp_mx),
     +        imcso(nmimp_mx), iso, indmc(nmimp_mx),
     +        imimc(nmimp_mx), indz(nmimp_mx)
      real zso(nmimp_mx), zmi(nmimp_mx)

      integer ii, jaux, mimp, cmp
      real zold

#include "auto/GEO.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"

      if (jmtra.le.0.or.jmimp.le.0) then ! check if MC tables exist
         do imc=1,nmc_mx      
            istamh(imc) = 0
            nmimmh(imc) = 0
         enddo
         go to 999
      endif

*     **** check if update necessary
      if (nevents.eq.evntmh.and.nmimp().eq.mimpmh) go to 999

*     **** loop over mimps in mimp bank, skip imc=0
      nso = 0
      do 10 imi=1,iq(jmimp+2)
       imc = omimp_mtra(imi)
       if (imc.gt.nmc_mx) then
        print *,' () tusomh: overflowing imc=', imc
        go to 10
       endif
       if (imc.gt.0) then
        if (nso.ge.nmimp_mx) then
         print *,' () tusomh: nso overflow, nso=', nso
         stop 'tusomh'
        endif
        cmp = igede_cmp(imimp_gede(imi))
        if (cmp.lt.1.or.cmp.gt.4) go to 10  ! only tracker mimps
        nso = nso + 1
        imiso(nso)  = imi
        imcso(nso) = imc
**        zso(nso)   = fmimp_z(imi)
        zso(nso)   = fmimp_time(imi)
       endif
 10   continue

*     **** sort according to ascending imc
      call sortzv(imcso,indmc,nso,-1,0,0)

*     **** count
      call vzero(istamh,nmc_mx)
      call vzero(nmimmh,nmc_mx)

      do imi=1,nso
       iso = indmc(imi)
       imc = imcso(iso)
       zmi(imi) = zso(iso)
       if (nmimmh(imc).eq.0) imimc(imc) = imi
       nmimmh(imc) = nmimmh(imc) + 1
      enddo

*     **** sort z
      imh = 0
      do imc=1,nmc_mx
       if (nmimmh(imc).gt.0) then


*         **** test: locate mimps according to relation to mt
          do ii=1,99
             if (ii.eq.1) then
                jaux = pmtra_mimp(imc)
                zold = -999999.
             else
                jaux = xmtra_mimp(jaux)
                zold = fmimp_z(mimp)
             endif
             if (jaux.eq.0) go to 11
             mimp = mmtra_mimp(jaux)
**             if (ii.gt.1) then
**                if (fmimp_z(mimp).gt.zold) then
**                   print *,' tusomh: out of sequence, imc,ii,z,zold=',
**     +                  imc,ii,fmimp_z(mimp),zold
**                endif
**             endif
          enddo
 11       continue


        call sortzv(zmi(imimc(imc)),indz,nmimmh(imc),+1,0,0)
        istamh(imc) = imh
        do iii=1,nmimmh(imc)
         imh = imh + 1
         if (imh.ge.nmimp_mx) then
          print *,' () tusomh: imh overflow, imh=', imh
          stop 'tusomh'
         endif
         imimmh(imh) = imiso(indmc(indz(iii)+imimc(imc)-1))
        enddo
       endif
*      **** clear ref and gold flags
       ref_mh(imc) = .false.
       gold_mh(imc) = .false.
      enddo

*     **** locate the golden b0
      call tulocb0()

*     **** update complete
      evntmh = nevents
      mimpmh = nmimp()


 999  end
