
// *****************************************************************************
//
// source:    rcClassFCNC.C
//
// type:      source code
//
// created:   20 Jun 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassFCNC
//
// called by: rcClassify
//
// purpose:   check for FCNC event
//
// hints:     do NOT set flagdst here!
//
// changes:
// 20 Jun 2000 (AG) creation
//  7 Jul 2000 (AG) polished code
//
// *****************************************************************************

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

//
// function code
//
int
rcClassFCNC()
{
  // inits
  int rc = 0;

  // invoke FCNC finder
  ARTE_mark( "FCNC", 0 );
  //rc = ;

  return rc;
}
