#include "wax/DecodeManager.hh"
#include "wax/RTManager.hh"

extern "C" 
{
  extern char* ku_gets();
  extern void kugeti_(int&);

  void waxSetListOfTablesFileName() {
    /* KUIP entry */
    char filename[80];
    strcpy(filename, ku_gets());
    waxDecodeManager::SetListOfTablesFileName(filename) ;
  }
  
  void waxSetTdcFedFileName() {
    /* KUIP entry */
    char filename[80];
    strcpy(filename, ku_gets());
    waxDecodeManager::SetTdcFedFileName(filename) ;
  }
  
  void waxSetTZeroFileName() {
    /* KUIP entry */
    char filename[80];
    strcpy(filename, ku_gets());
    waxDecodeManager::SetTZeroFileName(filename) ;
  }

  void waxSetMaskFileName() {
    /* KUIP entry */
    char filename[80];
    strcpy(filename, ku_gets());
    waxDecodeManager::SetMaskFileName(filename) ;
  }

  void waxSetSwapCableFileName() {
    /* KUIP entry */
    char filename[80];
    strcpy(filename, ku_gets());
    waxDecodeManager::SetSwapCableFileName(filename) ;
  }

  void waxSetDSRConfigDirName() {
    /* KUIP entry */
    char dirname[80];
    strcpy(dirname, ku_gets());
    waxRTManager::SetConfigDirName(dirname) ;
  }
  
  void waxSetMinTdcCount() {
    int i;
    kugeti_(i) ;
    waxDecodeChannel::SetMinTdcCount(i) ;
  }
  
  void waxSetMaxTdcCount() {
    int i;
    kugeti_(i) ;
    waxDecodeChannel::SetMaxTdcCount(i) ;
  }
  
  void waxSetTimeDiffWindow() { 
    int i;
    kugeti_(i) ;
    waxDecodeManager::SetTimeDiffWindow(i) ;
  }
  
  void waxSetNoiseSuppressionLevel() {
    int i;
    kugeti_(i) ;
    waxDecodeManager::SetNoiseSuppressionLevel(i) ;
  }

  void waxSetMaxNHitsSL() {
    int i;
    kugeti_(i) ;
    waxDecodeManager::SetMaxNHitsSL(i) ;
  }

  void waxSetMaxNHitsDL() {
    int i;
    kugeti_(i) ;
    waxDecodeManager::SetMaxNHitsDL(i) ;
  }

}
