
/**********************************************************************/
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/cluearte/MC_Track.C,v $
// $Revision: 1.5 $
// $Author: natasha $
// $Date: 1999/11/02 17:44:56 $
//
// Created: 07-23-99,   C. Borgmeier
//
/**********************************************************************/


#include <Clue/MC_Track.hh>
#include <Clue/MC_Vertex.hh>


MC_Track::MC_Track( ArtePointer<MTRA> mtra, ArtePointer<MC_Vertex> ve )
  : px( mtra->px ),
    py( mtra->py ),
    pz( mtra->pz ),
    mass( mtra->mass ),
    topp( *( ArteTable<ClTOPP>::begin()
	     + ( ArteTable<TOPP>::iterator( mtra->topp )
		 - ArteTable<TOPP>::begin() ) ) ),
    bVertex( ve ),
    mother( 0 )
{
  //SetLineColor( 3 );
}
