#include "dbarte/DbArteBridge.h"

extern DbFileDesc *DbFileDescList;

void dbstop_(void) {

  /*************************************************************************
   *
   * Author: HERA-B Bologna.
   * 31.08.98: Modified by A. Semenov (JINR, Dubna)
   *
   * Description: Close files before exit.
   *
   * Called from: ATSTOP
   *
   * External references: DbClose
   *
   ************************************************************************/


   DbFileDesc *FD;
   int ierr;

   for(FD=DbFileDescList;FD;FD=FD->next)
	   if(FD->active)
		   DbClose(FD->lun,&ierr);

}

