*CMZ :  1.00/01 10/02/95  19.40.16  by  Alexander Snizhko
*-- Author :    Alexander Snizhko   10/02/95
************************************************************************
*
* L1PADINT
* written by Alexander Snizhko, 10/02/95 19.28.45
*
* This routines action:
* Checks weather there is intersection of rectangular given by XYsize
* vector and XYsec vector (1-xleft,2-xright,3- ylow, 4- yhigh)
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* XYsize      in              see above
* XYsec       in
* iNTER       out            1 if yes, 0 if no.
*
************************************************************************
c
      SUBROUTINE L1PADINT(XYsize,XYsec,iNTER)

c
      IMPLICIT NONE
      INTEGER INTER
      REAL XYsize(4),XYsec(4)
c
      iNTER=0
      if(XYsize(2).lt.XYsec(1)) RETURN
      if(XYsize(1).gt.XYsec(2)) RETURN
      if(XYsize(4).lt.XYsec(3)) RETURN
      if(XYsize(3).gt.XYsec(4)) RETURN
      iNTER=1

      RETURN
c
      END
