
#ifndef _L4T_HH_
#define _L4T_HH_

// *****************************************************************************
//
// source:    l4t.hh
//
// type:      include file
//
// created:   14 Jan 1998
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// changes:
// 24 Nov 1999 (AG) change to new functions
// 25 Jan 2000 (AG) remove l4tStop()
// 22 Feb 2000 (AG) add defines
//
// *****************************************************************************

enum L4_code {
  L4_OFF,
  L4_ON,
  L4_KEEP,
  L4_REJECT
};

// prototypes
int l4tInit();
int l4tEvnt();

#endif
