*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE LIDDE1 (LUN, IR)

************************************************************************
*
* Description: list entry in the data description table
*
* Called from: KUIP etc.
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit number for output
*                 (not necessarily a printer)
*   IR     in     row number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDCOM.fi"
#include "arte/ZDDEFP.fi"

      INTEGER LUN, IR, LENOCC, IFLAG
      CHARACTER CC*120, CN*80, COMMAND(23)*7, CT*80, CDIV(2)*1, C16*16
      DATA COMMAND /'Ddefini','Dtable ','Drelat ','Dmenu  ','Dnamseq',
     +    'Dattrib','Dpoint ','Drelone','Drelman','Dinvone','Dinvman',
     +    'Dfile  ','Dtext  ','Dsub_of','Dpar_to','Dend_o ','Dirange',
     +    'Dilower','Diupper','Dfrange','Dflower','Dfupper','Dnbits '/
      DATA CDIV /'C','E'/

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

C command

      IFLAG = IDDEF_FLAG(IR)
      IF (IFLAG .LE. LDDEF_SKP)  GO TO 90
      CC = COMMAND(IFLAG+1)
      IF (IFLAG .EQ. LDDEF_INI .OR.
     +    IFLAG .EQ. LDDEF_END)  GO TO 80
      IF (IFLAG .GE. LDDEF_IRA .AND.
     +    IFLAG .LE. LDDEF_NBI)  GO TO 60

      IF (IFLAG .EQ. LDDEF_FIL)  GO TO 70
      IF (IFLAG .EQ. LDDEF_TEX)  GO TO 70

C name

      CALL CHHTOC (IQ(HQDDEF_NAME(1,IR)), CN)
      IF (IFLAG .NE. LDDEF_TAB)  CALL CUTOL (CN)
      CALL CHAPBC (CC(9:), CN)

      IF (IFLAG .EQ. LDDEF_NAM)  GO TO 80
      IF (IFLAG .EQ. LDDEF_POI)  GO TO 20
      IF (IFLAG .EQ. LDDEF_ATT)  GO TO 50
      IF (IFLAG .EQ. LDDEF_TAB)  GO TO 10
      IF (IFLAG .GT. LDDEF_INM)  GO TO 80

C relation name

      CALL CHHTOC (IQ(HQDDEF_NAM3(1,IR)), CN)
      CALL CHAPBC (CC(17:), CN)
      GO TO 70

C extension

 10   CALL CHAPBI (CC(17:), IDDEF_DIM(IR))

C division

      IF (IFLAG .NE. LDDEF_MEN)
     +  CALL CHAPBC (CC(25:), CDIV(IDDEF_DIV(IR)))

C menu name

      IF (HDDEF_NAM2(1,IR) .EQ. HBLANKSP)  GO TO 70
      CALL CHAPBC (CC(27:), '-')
      CALL CHHTOC (IQ(HQDDEF_NAM2(1,IR)), CN)
      CALL CHAPPC (CC, CN)
      GO TO 70

C pointer

 20   CALL CHHTOC (IQ(HQDDEF_NAM2(1,IR)), CN)
      CALL CHAPBC (CC(17:), CN)
      GO TO 70

C attribute

 50   CALL CHHTOC (IQ(HQDDEF_NAM2(1,IR)), CN)
      CALL CUTOL (CN)
      CALL CHAPBC (CC(17:), CN)
      CALL CHAPBI (CC, IDDEF_DIM(IR))
      IF (IDDEF_KEY(IR) .NE. 0)  CALL CHAPBC (CC, '-KEY')
      GO TO 70

C ranges

 60   IF (IFLAG .LE. LDDEF_IUP)  THEN
        IF (IFLAG .LE. LDDEF_ILO)
     +    CALL CHAPBI (CC,  IDDEF_RFLG(IR))
        IF (IFLAG .NE. LDDEF_ILO)
     +    CALL CHAPBI (CC,  IDDEF_DIV(IR))
      ELSE IF (IFLAG .LE. LDDEF_FUP)  THEN
        IF (IFLAG .LE. LDDEF_FLO)  THEN
          WRITE (C16, '(G13.7)')  FDDEF_FLO(IR)
          CALL CHLEFT (C16)
          CALL CHAPBC (CC, C16)
        END IF
        IF (IFLAG .NE. LDDEF_FLO) THEN
          WRITE (C16, '(G13.7)')  FDDEF_FUP(IR)
          CALL CHLEFT (C16)
          CALL CHAPBC (CC, C16)
        END IF
      ELSE
        CALL CHAPBI (CC,  IDDEF_RFLG(IR))
      END IF
      GO TO 80

C comment

 70   CALL CHHTOC (IQ(HQDDEF_TEXT(1,IR)), CT)
      IF (CT .NE. ' ')  THEN
        IF (LENOCC (CC(31:)) + LENOCC(CT) .GT. 49)  THEN
          CALL CHAPBC (CC, '_')
          WRITE (LUN, '(1X,A)') CC(1:LENOCC(CC))
          CC = ' '
        END IF
        CALL CHAPBC (CC(35:), '''')
        CALL CHAPPC (CC, CT)
        CALL CHAPPC (CC, '''')
      END IF

 80   WRITE (LUN, '(1X,A)') CC(1:LENOCC(CC))

 90   END

************************************************************************
* End of LIDDE1
************************************************************************
