
* B.Fominykh  16.06.98
* updated 14.04.2000
* the routine of the MuonID package
* manages the grouth of the track tree
*
      SUBROUTINE MURTREE
C     ==================
      IMPLICIT NONE
      INTEGER NSEED,NHITS,IS,ISS,IOUT,ISTAR,IPR
      INTEGER IDEBPR,IBRBEST,JS,IRS,IRT,JT,IRTT
*
#include "murec/MUCBTAB.fi"
#include "murec/MUCBZDT.fi"
#include "murec/MUCKALF.fi"
#include "murec/MUCONT.fi"
#include "arte/Arte.fi"
#include "auto/EVHD.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/RTRA.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      NSEED=IQ(JTMP6+2)
      NHITS=IQ(JTMP8+2)
      IF(IPRSC.GT.0) PRINT 1001, NSEED,NHITS
      IF(IPRLG.GT.0) WRITE(LLOGF,1001) NSEED,NHITS
 1001 FORMAT(2X,'*** MURTREE starts with',I4,' seeds and',
     +       I4,' clusters')
      IF(NSEED.LE.0) GOTO 200
      IF(NHITS.LE.0) GOTO 200
*
      IFREE=1               ! 1st row is free
      DO 50 IS=1,NSEED
        CALL MURTRIN(IS,IOUT)
        IF(IOUT.NE.1) GOTO 200
        ISTAR=IFREE
        ISS=ISDORD(IS)
        JS=JTMP6+IQ(JTMP6+1)*(ISS-1)+2

* set a debug control
        IDEBPR=-1
* event number
*        IF(IQ(JEVHD+JEVHD_EVT+2).EQ.77) THEN
*          IDEBPR=-1
* seed number
*          IF(ISDORD(IS).EQ.5) IDEBPR=1
*        ENDIF

        IF(IDEBPR.GT.0) WRITE(LLOGF,*)
     +   '*** debug for seed', ISDORD(IS),' ISTAR,IFREE',ISTAR,IFREE

* make a track tree for one seed
        CALL MURTRG(ISTAR,IDEBPR)

        IF(IDEBPR.GT.0) WRITE(LLOGF,*)
     +   '*** MURTRG end for seed ', ISDORD(IS),
     +   ' ISTAR,IFREE',ISTAR,IFREE
* no action if no branchs  
        IF(ISTAR.GE.IFREE) GOTO 50

* +1 to muon flag of related RTRA tracks
        IF(IQ(JS+79).GT.0) THEN
          DO IRTT=1,IQ(JS+79)
            IRT=IQ(JS+IRTT+79)
            JT=JRTRA+IQ(JRTRA+1)*(IRT-1)+2
            IQ(JT+JRTRA_FLM)=IQ(JT+JRTRA_FLM)+1
          ENDDO
        ENDIF
* estimate the track quality
        CALL MURTRQU(ISTAR,IFREE-1)
* calculate likelyhood probability for branchs
        CALL MURBLHP(ISTAR,IFREE-1,0)

* selection of the best branch for the seed
        IPR=0
        IF(IDEBPR.GT.0) IPR=1
        CALL MURSEL1B(IPR,ISTAR,IFREE-1)
* print the selected branch
        IF(IPR.GT.0) CALL MURTRPRB(1,ISTAR,IFREE-1)

* +1 to muon flag if the best branch is selected
        IF(ISTAR.EQ.IFREE-1) THEN
          IF(IQ(JS+79).GT.0) THEN
            DO IRTT=1,IQ(JS+79)
              IRT=IQ(JS+IRTT+79)
              JT=JRTRA+IQ(JRTRA+1)*(IRT-1)+2
              IQ(JT+JRTRA_FLM)=IQ(JT+JRTRA_FLM)+1
              IF(IPRLG.GT.0)
     +        PRINT*,'MURTREE: seed,segm,RTRA',ISS,IQ(JS+3),IRT,
     +           ' best branch is seleced'
            ENDDO
          ENDIF
        ENDIF

*        IF(IBRBEST.GT.0) PRINT*, 'MURTREE-MC: seed,segm',
        IF(IPRLG.GT.0) PRINT*, 'MURTREE-MC: seed,segm',
     +   ISS,IQ(JS+3),' BR1,BR2,BRBEST',ISTAR,IFREE-1,IBRBEST

        IF(IDEBPR.GT.0) WRITE(LLOGF,*)
     +  '*** end for seed', ISDORD(IS),' ISTAR,IFREE',ISTAR,IFREE

        IF(IFREE.GE.NBMUTR) GOTO 200

  50  CONTINUE
*
 200  CONTINUE
      RETURN
      END

