*CMZ :  2.07/01 16/08/94  14.40.21  by  Rainer Mankel
*-- Author :    Rainer Mankel   16/08/94

      subroutine dicyl(z1,z2,x0,y0,r)

*     **** display drifttime-cylinder for gas pixels
      implicit none
#include "pris/zgraf.fi"

      integer npt, ii, iimin, iimax
      parameter (npt=31)
      real xxx(npt,2), yyy(npt,2), phi, dphi, z1, z2, x0, y0, r, vec(3)
      real ppp(2), qqq(2)

      dphi = 6.283185 / (npt-1)
      iimax = 0
      iimin = 0
      do 10 ii=1,npt
       if (ii.eq.npt) then
        phi = dphi
       else
        phi = ii * dphi
       endif

       vec(1) = x0 + r * cos(phi)
       vec(2) = y0 + r * sin(phi)
       vec(3) = z1
*      **** front ellipse
       call dipro(vec,xxx(ii,1),yyy(ii,1))
*      **** back ellipse
       vec(3) = z2
       call dipro(vec,xxx(ii,2),yyy(ii,2))
*      **** store max/min
       if (iimax.eq.0) then
        iimax = ii
       else
        if (yyy(ii,1).gt.yyy(iimax,1)) iimax = ii
       endif
       if (iimin.eq.0) then
        iimin = ii
       else
        if (yyy(ii,1).lt.yyy(iimin,1)) iimin = ii
       endif

 10   continue

*     **** draw front ellipse
      call igraph(npt,xxx(1,1),yyy(1,1),'L')
*     **** draw back ellipse
      call igraph(npt,xxx(1,2),yyy(1,2),'L')
*     **** draw connecting lines
      ppp(1) = xxx(iimin,1)
      qqq(1) = yyy(iimin,1)
      ppp(2) = xxx(iimin,2)
      qqq(2) = yyy(iimin,2)
      call ipl(2,ppp,qqq)
      ppp(1) = xxx(iimax,1)
      qqq(1) = yyy(iimax,1)
      ppp(2) = xxx(iimax,2)
      qqq(2) = yyy(iimax,2)
      call ipl(2,ppp,qqq)

      end
