// See io_cell_states.hh for details.

// Author: Vladislav Balagura (balagura@hera-b.desy.de, 03.11.1999)

#include "ptset/io_cell_states.hh"

class Write_Cell_States {
  ostream& os;
public:
  Write_Cell_States(ostream& fOs) : os(fOs) {}
  /*
  template <class CellT, SectionT, ChamberTSetupT>
  void operator()(Setup<...>) {...}
  */
  void operator()(HPT_Setup& setup) { write_cell_states(setup, os); }
};

void write_cell_states(Detector& det, const string& setup, ostream& os) {
  os << "/sub-detector{ " << setup << '\n';
  apply_virtually(Write_Cell_States(os))(det, setup);
  os << "}\n";
}
