      SUBROUTINE RITER_EVNT

#include "riter/RIC_TRA.fi"
#include "riter/RIC_PHOT.fi"

      CHARACTER*80 TXT
      INTEGER ERR1,ERR2,ERR3,ERR4
      SAVE ERR1,ERR2,ERR3,ERR4

      CALL RITER(IER)

      IF(IER.EQ.0) THEN
         CALL FILL_RICH_HISTOS
      ELSE IF(IER.EQ.-1) THEN
         CALL MEPRIC(ERR1,10,'RITER error: load_geo_ - missing data') 
      ELSE IF(IER.EQ.-2) THEN
         CALL MEPRIC(ERR2,10,'RITER error: - riter NOT enabled') 
      ELSE IF(IER.GT.0) THEN
         CALL MEPRIC(ERR3,100,
     &        'RITER warning: - giving up, occupancy too large') 
      ELSE
         CALL MEPRIC(ERR4,10,'RITER error: unknown')
      ENDIF

      RETURN
      END



      SUBROUTINE SWITCH_RICH_HISTOS( ISWITCH )

#include "riter/RIC_PHOT.fi"
      HISTO_ON = ISWITCH

      RETURN
      END



      SUBROUTINE FILL_RICH_HISTOS

#include "riter/RIC_TRA.fi"
#include "riter/RIC_PHOT.fi"
#include "riter/RIC_CHA.fi"
#include "riter/RIC_PAR.fi"

      IF ( HISTO_ON.EQ.0 ) RETURN 

      NTRA_RECO=0
      DO ITRA=1,NTRA
         IF(RECO_FLAG(ITRA).EQ.1) NTRA_RECO=NTRA_RECO+1
      ENDDO
      CALL GET_RING_TAB_ROWS(NT)

      CALL RHFILL(1001,FLOAT(NTRA),0.,1.)
      CALL RHFILL(1002,FLOAT(NTRA_RECO),0.,1.)
      CALL RHFILL(1003,FLOAT(NFOT),0.,1.)
      CALL RHFILL(1004,FLOAT(NT),0.,1.)

      ETA00=ETA
      IF(ETA00.LE.0) ETA00=1.
      ITRA_OLD=-1
      DO K=1,NT
         CALL GET_RING_TAB(K,ITRA,IFOT,SIG,THCER,FICER,WT)
         IF(ITRA.NE.ITRA_OLD) THEN
            ITRA_OLD=ITRA
            CALL RHFILL(1005,T_MOM(ITRA),0.,1.)
            CALL RHFILL(1006,FLOAT(PID(ITRA)),0.,1.)
            STF=STFS(3,ITRA)/ETA00
            IF(T_MOM(ITRA).GT.15) CALL RHFILL(1009,STF,0.,1.)
            TLOGP=LOG(T_MOM(ITRA))
            IF(TLOGP.GT.1) CALL RHFILL(1012,TLOGP,STF,1.)
         ENDIF
         IF(T_MOM(ITRA).GT.15) THEN
            CALL RHFILL(1007,THCER,0.,WT)
            CALL RHFILL(1008,THCER,0.,1.)
            II=1
            IF(T_R(1,ITRA).LT.0) II=0
            IF(RF(2,IFOT).LT.0) II=II+2
            CALL RHFILL(1013+II,FICER,THCER,WT)
         ENDIF
         IF(TLOGP.GT.1) THEN
            CALL RHFILL(1010,TLOGP,THCER-THC(3,ITRA),WT)
            CALL RHFILL(1011,TLOGP,THCER-THC(3,ITRA),1.)
         ENDIF
      ENDDO

      RETURN
      END
 






